Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/asmtest.S
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/tests/asmtest.S	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/asmtest.S	(revision 331)
@@ -12,12 +12,20 @@
    .byte 1
 /* .align 16, 0x90 gas is too clever for us with 0x90 fill */
+   .balign 4, 0x92
    .align 16, 0x91 /* 0x91 tests the non-clever behaviour */
    .skip 3
    .skip 15, 0x90
    .string "hello\0world"
-
+/* Macro expansion should work like with C, the #n shouldn't be parsed
+   as asm line comment */
+#define __stringify(n) #n
+#define stringify(n) __stringify(n)
+   .skip 8,0x90
+   .asciz stringify(BLA)
+   .skip 8,0x90
+
+# 28 "asmtest.S"        # a line directive (and a line comment)
+        movl %eax, %ebx # some more asm comment
 /* some label tests */
-
-        movl %eax, %ebx
 L1:
         movl %eax, %ebx
@@ -39,5 +47,5 @@
 mov $1, %edx
 mov $1, %dx
-mov $1, %dl
+mov $1, %cl
 movb $2, 0x100(%ebx,%edx,2)
 movw $2, 0x100(%ebx,%edx,2)
@@ -47,6 +55,19 @@
 movw %ax, 0x100(%ebx,%edx,2)
 
+movw $0x1122,%si
+movl $0x112233,%edx
+movl $0x80000000, %esi
+movl $-0x7fffffff, %edi
+#ifdef __x86_64__
+mov $0x11223344,%rbx
+movq $0x11223344,%rbx
+mov $0x1122334455,%rbx
+movq $0x1122334455,%rbx
+movl $0x11334455,(%rbx)
+#endif
+
 mov %eax, 0x12(,%edx,2)
         
+#ifdef __i386__
 mov %cr3, %edx
 mov %ecx, %cr3
@@ -55,6 +76,31 @@
 movl %db3, %ebx
 movl %dr6, %eax
+#else
+mov %cr3, %rdx
+mov %rcx, %cr3
+movq %cr3, %rax
+movq %db3, %rbx
+movq %dr6, %rax
+mov %cr8, %rsi
+mov %rdi, %cr8
+#endif
 movl %fs, %ecx
 movl %ebx, %fs
+
+#ifdef __x86_64__
+movq %r8, %r9
+movq %r10, %r11
+movq %r12, %r13
+movq %r14, %r15
+movq %rax, %r9
+movq %r15, %rsi
+inc %r9b
+dec %r10w
+not %r11d
+negq %r12
+decb %r13b
+incw %r14w
+notl %r15d
+#endif
 
      movsbl 0x1000, %eax
@@ -69,17 +115,45 @@
      movzb 0x1000, %ax
                 
+     mov $0x12345678,%eax
+
+#ifdef __x86_64__
+     movzb 0x1000, %rax
+     movzbq 0x1000, %rbx
+     movsbq 0x1000, %rdx
+     movzwq 0x1000, %rdi
+     movswq 0x1000, %rdx
+     movslq %eax, %rcx
+     mov $0x12345678,%rax
+     mov $0x12345678,%rdx
+     mov $0x12345678,%r10
+     mov $0x123456789abcdef0,%rax
+     mov $0x123456789abcdef0,%rcx
+     mov $0x123456789abcdef0,%r11
+#endif
         
+#ifdef __i386__
   pushl %eax
-  pushw %ax
   push %eax
   push %cs
+#else
+  pushq %rax
+  push %rax
+#endif
+  pushw %ax
   push %gs
   push $1
   push $100
+  push 0x42(%eax)
+  pop 0x43(%esi)
                                                 
+#ifdef __i386__
   popl %eax
-  popw %ax
   pop %eax
   pop %ds
+#else
+  popq %rax
+  pop %rax
+#endif
+  popw %ax
   pop %fs
           
@@ -112,12 +186,32 @@
   lea 0x1000(%ebx), %ecx
 
+#ifdef __i386__
   les 0x2000, %eax
   lds 0x2000, %ebx
+  lss 0x2000, %edx
+#endif
   lfs 0x2000, %ecx
   lgs 0x2000, %edx
-  lss 0x2000, %edx
 
 addl $0x123, %eax
 add $0x123, %ebx
+add $-16, %ecx
+add $-0x123, %esi
+add $1, %bx
+add $1, %ebx
+add $-1, %bx
+add $-1, %ebx
+add $127, %bx
+addl $127, %ebx
+addl $-128, %ebx
+addl $-128, %ebx
+addl $-129, %ebx
+addl $128, %ebx
+addl $255, %ebx
+addl $256, %ebx
+andb $0xf, %ah
+andb $-15, %cl
+xorb $127, %dh
+cmpb $42, (%eax)
 addl $0x123, 0x100
 addl $0x123, 0x100(%ebx)
@@ -128,4 +222,22 @@
 addl $0x123, (%esp)
 cmpl $0x123, (%esp)
+
+#ifdef __x86_64__
+xor %bl,%ah
+xor %bl,%r8b
+xor %r9b,%bl
+xor %sil,%cl
+add %eax,(%r8d)
+add %ebx,(%r9)
+add %edx,(%r10d,%r11d)
+add %ecx,(%r12,%r13)
+add %esi,(%r14,%r15,4)
+add %edi,0x1000(%rbx,%r12,8)
+add %r11,0x1000(%ebp,%r9d,8)
+movb $12, %ah
+movb $13, %bpl
+movb $14, %dil
+movb $15, %r12b
+#endif
 
 add %eax, (%ebx)
@@ -180,4 +292,6 @@
     div %ecx, %eax
 
+and $15,%bx
+and $-20,%edx
 
 shl %edx
@@ -196,5 +310,9 @@
 call 0x1000
 call L4
+#ifdef __i386__
 call *%eax
+#else
+call *%rax
+#endif
 call *0x1000
 call func1
@@ -205,17 +323,38 @@
 L6:
 
+#ifdef __i386__
 lcall $0x100, $0x1000
+#else
+lcall *0x100
+lcall *(%rax)
+#endif
 
 jmp 0x1000
+jmp *(%edi)
+#ifdef __i386__
 jmp *%eax
+#else
+jmp *%rax
+#endif
 jmp *0x1000
 
+#ifdef __i386__
 ljmp $0x100, $0x1000
+#else
+ljmp *0x100
+ljmp *(%rdi)
+ljmpl *(%esi)
+ljmpw *(%esi)
+#endif
 
 ret
+ret $10
+#ifdef __i386__
 retl
-
-ret $10
 retl $10
+#else
+retq
+retq $10
+#endif
 
 lret
@@ -245,4 +384,6 @@
         
  seto %al
+ setc %al
+ setcb %al
  setnp 0x1000
  setl 0xaaaa
@@ -402,4 +543,5 @@
 
 bswap %edx
+bswapl %ecx
 xadd %ecx, %edx
 xaddb %dl, 0x1000
@@ -412,4 +554,8 @@
 invlpg 0x1000
 cmpxchg8b 0x1002
+#ifdef __x86_64__
+cmpxchg16b (%rax)
+cmpxchg16b (%r10,%r11)
+#endif
 
 fcmovb %st(5), %st
@@ -431,12 +577,23 @@
  cmovs 0x1000, %eax
  cmovns %edx, %edi
+ cmovne %ax, %si
+ cmovbw %ax, %di
+ cmovnbel %edx, %ecx
+#ifdef __x86_64__
+ bswapq %rsi
+ bswapq %r10
+ cmovz %rdi,%rbx
+ cmovpeq %rsi, %rdx
+#endif
 
 int $3
 int $0x10
 
+#ifdef __i386__
     pusha
     popa
-    clc
-    cld
+#endif
+    clc # another comment
+    cld # a comment with embedded ' tick
     cli
     clts
@@ -444,6 +601,11 @@
     lahf
     sahf
+#ifdef __i386__
     pushfl
     popfl
+#else
+    pushfq
+    popfq
+#endif
     pushf
     popf
@@ -451,4 +613,5 @@
     std
     sti
+#ifdef __i386__
     aaa
     aas
@@ -457,4 +620,6 @@
     aad
     aam
+    into
+#endif
     cbw
     cwd
@@ -467,5 +632,4 @@
     leave
     int3
-    into
     iret
     rsm
@@ -512,5 +676,32 @@
     rdpmc
     ud2
-
+#ifdef __x86_64__
+    syscall
+    sysret
+    sysretq
+    lfence
+    mfence
+    sfence
+    prefetchnta 0x18(%rdx)
+    prefetcht0 (%rcx)
+    prefetcht1 (%rsi)
+    prefetcht2 (%rdi)
+    prefetchw (%rdi)
+    clflush 0x1000(%rax,%rcx)
+    fxsaveq (%rdx)
+    fxsaveq (%r11)
+    fxrstorq (%rcx)
+    fxrstorq (%r10)
+
+#endif
+
+    lar %ax,%dx
+    lar %eax,%dx
+    lar %ax,%edx
+    lar %eax,%edx
+#ifdef __x86_64__
+    lar %ax,%rdx
+    lar %eax,%rdx
+#endif
     emms
     movd %edx, %mm3
@@ -557,25 +748,42 @@
         
         
+#ifdef __i386__
     boundl %edx, 0x10000
     boundw %bx, 0x1000
-    
+
     arpl %bx, 0x1000
+#endif
     lar 0x1000, %eax
     lgdt 0x1000
     lidt 0x1000
     lldt 0x1000
+    sgdt 0x1000
+    sidt 0x1000
+    sldt 0x1000
+#ifdef __x86_64__
+    lgdtq 0x1000
+    lidtq 0x1000
+    sgdtq 0x1000
+    sidtq 0x1000
+
+    swapgs
+
+    str %rdx
+    str %r9
+#endif
+
     lmsw 0x1000
     lsl 0x1000, %ecx
     ltr 0x1000
-    
-    sgdt 0x1000
-    sidt 0x1000
-    sldt 0x1000
+    ltr %si
     smsw 0x1000
     str 0x1000
+    str %ecx
+    str %dx
     
     verr 0x1000
     verw 0x1000
   
+#ifdef __i386__
     push %ds
     pushw %ds
@@ -584,7 +792,12 @@
     popw %ds
     popl %ds
+#endif
     fxsave 1(%ebx)
     fxrstor 1(%ecx)
+#ifdef __i386__
     pushl $1
+#else
+    pushq $1
+#endif
     pushw $1
     push $1
@@ -594,4 +807,5 @@
 #endif
 
+#ifndef _WIN32
 ft1: ft2: ft3: ft4: ft5: ft6: ft7: ft8: ft9:
     xor %eax, %eax
@@ -606,4 +820,159 @@
 .type ft7,%function
 .type ft8,"function"
+#endif
 
     pause
+.rept 6
+    nop
+.endr
+.fill 4,1,0x90
+
+.section .text.one,"ax"
+nop
+.previous
+.pushsection .text.one,"ax"
+nop
+.pushsection .text.two,"ax"
+nop
+.popsection
+.popsection
+
+1: ud2
+.pushsection __bug_table,"a"
+.align 8
+2: .long 1b - 2b
+   .long 0x600000 - 2b
+   .long 1b + 42
+   .long 43 + 1b
+   .long 2b + 144
+   .long 145 + 2b
+   .word 164, 0
+   .org 2b+32
+#ifdef __x86_64__
+   .quad 1b
+#else
+   .long 1b
+#endif
+.popsection
+3: mov %eax,%ecx
+4:
+.pushsection .text.three, "ax"
+nop
+.skip (-((4b-3b) > 0) * 2) , 0x90
+.popsection
+
+.globl overrideme
+.weak overrideme
+  nop
+.globl notimplemented
+notimplemented:
+  ret
+.set overrideme, notimplemented
+overrideme = notimplemented
+overrideme:
+  ret
+
+    movd %esi, %mm1
+    movd %edi, %xmm2
+    movd (%ebx), %mm3
+    movd (%ebx), %xmm3
+    movd %mm1, %esi
+    movd %xmm2, %edi
+    movd %mm3, (%edx)
+    movd %xmm3, (%edx)
+#ifdef __x86_64__
+    movd %rsi, %mm1
+    movd %rdi, %xmm2
+    movd (%rbx), %mm3
+    movd (%rbx), %xmm3
+    movd %mm1, %r12
+    movd %xmm2, %rdi
+    movd %mm3, (%r8)
+    movd %xmm3, (%r13)
+#endif
+
+    movq (%ebp), %mm1
+    movq %mm2, (%edi)
+    movq (%edi), %xmm3
+    movq %mm4, %mm5
+#ifdef __x86_64__
+    movq %rcx, %mm1
+    movq %rdx, %xmm2
+    movq %r13, %xmm3
+    /* movq mem64->xmm is encoded as f30f7e by GAS, but as
+       660f6e by tcc (which really is a movd and would need 
+       a REX.W prefix to be movq).  */
+    movq (%rsi), %xmm3
+    movq %mm1, %rdx
+    movq %xmm3, %rcx
+    movq %xmm4, (%rsi)
+#endif
+
+#define TEST_MMX_SSE(insn) \
+    insn %mm1, %mm2; \
+    insn %xmm2, %xmm3; \
+    insn (%ebx), %xmm3;
+#define TEST_MMX_SSE_I8(insn) \
+    TEST_MMX_SSE(insn) \
+    insn $0x42, %mm4; \
+    insn $0x42, %xmm4;
+
+    TEST_MMX_SSE(packssdw)
+    TEST_MMX_SSE(packsswb)
+    TEST_MMX_SSE(packuswb)
+    TEST_MMX_SSE(paddb)
+    TEST_MMX_SSE(paddw)
+    TEST_MMX_SSE(paddd)
+    TEST_MMX_SSE(paddsb)
+    TEST_MMX_SSE(paddsw)
+    TEST_MMX_SSE(paddusb)
+    TEST_MMX_SSE(paddusw)
+    TEST_MMX_SSE(pand)
+    TEST_MMX_SSE(pandn)
+    TEST_MMX_SSE(pcmpeqb)
+    TEST_MMX_SSE(pcmpeqw)
+    TEST_MMX_SSE(pcmpeqd)
+    TEST_MMX_SSE(pcmpgtb)
+    TEST_MMX_SSE(pcmpgtw)
+    TEST_MMX_SSE(pcmpgtd)
+    TEST_MMX_SSE(pmaddwd)
+    TEST_MMX_SSE(pmulhw)
+    TEST_MMX_SSE(pmullw)
+    TEST_MMX_SSE(por)
+    TEST_MMX_SSE(psllw)
+TEST_MMX_SSE_I8(psllw)
+    TEST_MMX_SSE(pslld)
+TEST_MMX_SSE_I8(pslld)
+    TEST_MMX_SSE(psllq)
+TEST_MMX_SSE_I8(psllq)
+    TEST_MMX_SSE(psraw)
+TEST_MMX_SSE_I8(psraw)
+    TEST_MMX_SSE(psrad)
+TEST_MMX_SSE_I8(psrad)
+    TEST_MMX_SSE(psrlw)
+TEST_MMX_SSE_I8(psrlw)
+    TEST_MMX_SSE(psrld)
+TEST_MMX_SSE_I8(psrld)
+    TEST_MMX_SSE(psrlq)
+TEST_MMX_SSE_I8(psrlq)
+    TEST_MMX_SSE(psubb)
+    TEST_MMX_SSE(psubw)
+    TEST_MMX_SSE(psubd)
+    TEST_MMX_SSE(psubsb)
+    TEST_MMX_SSE(psubsw)
+    TEST_MMX_SSE(psubusb)
+    TEST_MMX_SSE(psubusw)
+    TEST_MMX_SSE(punpckhbw)
+    TEST_MMX_SSE(punpckhwd)
+    TEST_MMX_SSE(punpckhdq)
+    TEST_MMX_SSE(punpcklbw)
+    TEST_MMX_SSE(punpcklwd)
+    TEST_MMX_SSE(punpckldq)
+    TEST_MMX_SSE(pxor)
+
+    cvtpi2ps %mm1, %xmm2
+    cvtpi2ps (%ebx), %xmm2
+    TEST_MMX_SSE(pmaxsw)
+    TEST_MMX_SSE(pmaxub)
+    TEST_MMX_SSE(pminsw)
+    TEST_MMX_SSE(pminub)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/boundtest.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/tests/boundtest.c	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/boundtest.c	(revision 331)
@@ -1,4 +1,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
 
 #define NB_ITS 1000000
@@ -50,4 +51,6 @@
     int *tab4;
 
+    fprintf(stderr, "%s start\n", __FUNCTION__);
+
     tab4 = malloc(20 * sizeof(int));
     for(i=0;i<20;i++) {
@@ -56,4 +59,5 @@
     free(tab4);
 
+    fprintf(stderr, "%s end\n", __FUNCTION__);
     return sum;
 }
@@ -64,4 +68,6 @@
     int i, sum = 0;
     int *tab4;
+
+    fprintf(stderr, "%s start\n", __FUNCTION__);
 
     tab4 = malloc(20 * sizeof(int));
@@ -71,4 +77,5 @@
     free(tab4);
 
+    fprintf(stderr, "%s end\n", __FUNCTION__);
     return sum;
 }
@@ -187,6 +194,41 @@
 }
 
+/* ok */
+int test16()
+{
+    char *demo = "This is only a test.";
+    char *p;
+
+    fprintf(stderr, "%s start\n", __FUNCTION__);
+
+    p = alloca(16);
+    strcpy(p,"12345678901234");
+    printf("alloca: p is %s\n", p);
+
+    /* Test alloca embedded in a larger expression */
+    printf("alloca: %s\n", strcpy(alloca(strlen(demo)+1),demo) );
+
+    fprintf(stderr, "%s end\n", __FUNCTION__);
+}
+
+/* error */
+int test17()
+{
+    char *demo = "This is only a test.";
+    char *p;
+
+    fprintf(stderr, "%s start\n", __FUNCTION__);
+
+    p = alloca(16);
+    strcpy(p,"12345678901234");
+    printf("alloca: p is %s\n", p);
+
+    /* Test alloca embedded in a larger expression */
+    printf("alloca: %s\n", strcpy(alloca(strlen(demo)),demo) );
+
+    fprintf(stderr, "%s end\n", __FUNCTION__);
+}
+
 int (*table_test[])(void) = {
-    test1,
     test1,
     test2,
@@ -204,4 +246,6 @@
     test14,
     test15,
+    test16,
+    test17,
 };
 
@@ -210,9 +254,11 @@
     int index;
     int (*ftest)(void);
+    int index_max = sizeof(table_test)/sizeof(table_test[0]);
 
     if (argc < 2) {
-        printf("usage: boundtest n\n"
-               "test TCC bound checking system\n"
-               );
+        printf(
+    	    "test TCC bound checking system\n"
+	    "usage: boundtest N\n"
+            "  1 <= N <= %d\n", index_max);
         exit(1);
     }
@@ -220,5 +266,11 @@
     index = 0;
     if (argc >= 2)
-        index = atoi(argv[1]);
+        index = atoi(argv[1]) - 1;
+
+    if ((index < 0) || (index >= index_max)) {
+        printf("N is outside of the valid range (%d)\n", index);
+        exit(2);
+    }
+
     /* well, we also use bounds on this ! */
     ftest = table_test[index];
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/libtcc_test.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/tests/libtcc_test.c	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/libtcc_test.c	(revision 331)
@@ -16,5 +16,14 @@
 }
 
+/* this strinc is referenced by the generated code */
+const char hello[] = "Hello World!";
+
 char my_program[] =
+"#include <tcclib.h>\n" /* include the "Simple libc header for TCC" */
+"extern int add(int a, int b);\n"
+"#ifdef _WIN32\n" /* dynamically linked data needs 'dllimport' */
+" __attribute__((dllimport))\n"
+"#endif\n"
+"extern const char hello[];\n"
 "int fib(int n)\n"
 "{\n"
@@ -27,5 +36,5 @@
 "int foo(int n)\n"
 "{\n"
-"    printf(\"Hello World!\\n\");\n"
+"    printf(\"%s\\n\", hello);\n"
 "    printf(\"fib(%d) = %d\\n\", n, fib(n));\n"
 "    printf(\"add(%d, %d) = %d\\n\", n, 2 * n, add(n, 2 * n));\n"
@@ -36,4 +45,5 @@
 {
     TCCState *s;
+    int i;
     int (*func)(int);
 
@@ -45,6 +55,15 @@
 
     /* if tcclib.h and libtcc1.a are not installed, where can we find them */
-    if (argc == 2 && !memcmp(argv[1], "lib_path=",9))
-        tcc_set_lib_path(s, argv[1]+9);
+    for (i = 1; i < argc; ++i) {
+        char *a = argv[i];
+        if (a[0] == '-') {
+            if (a[1] == 'B')
+                tcc_set_lib_path(s, a+2);
+            else if (a[1] == 'I')
+                tcc_add_include_path(s, a+2);
+            else if (a[1] == 'L')
+                tcc_add_library_path(s, a+2);
+        }
+    }
 
     /* MUST BE CALLED before any compilation */
@@ -54,7 +73,8 @@
         return 1;
 
-    /* as a test, we add a symbol that the compiled program can use.
+    /* as a test, we add symbols that the compiled program can use.
        You may also open a dll with tcc_add_dll() and use symbols from that */
     tcc_add_symbol(s, "add", add);
+    tcc_add_symbol(s, "hello", hello);
 
     /* relocate the code */
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/01.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/01.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/01.c	(revision 331)
@@ -0,0 +1,6 @@
+#define hash_hash # ## #
+#define mkstr(a) # a
+#define in_between(a) mkstr(a)
+#define join(c, d) in_between(c hash_hash d)
+char p[] = join(x, y);
+// char p[] = "x ## y";
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/01.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/01.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/01.expect	(revision 331)
@@ -0,0 +1,1 @@
+char p[] = "x ## y";
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/02.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/02.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/02.c	(revision 331)
@@ -0,0 +1,28 @@
+#define x 3
+#define f(a) f(x * (a))
+#undef x
+#define x 2
+#define g f
+#define z z[0]
+#define h g(~
+#define m(a) a(w)
+#define w 0,1
+#define t(a) a
+#define p() int
+#define q(x) x
+#define r(x,y) x ## y
+#define str(x) # x
+f(y+1) + f(f(z)) % t(t(g)(0) + t)(1);
+g(x+(3,4)-w) | h 5) & m
+(f)^m(m);
+char c[2][6] = { str(hello), str() };
+/*
+ * f(2 * (y+1)) + f(2 * (f(2 * (z[0])))) % f(2 * (0)) + t(1);
+ * f(2 * (2+(3,4)-0,1)) | f(2 * (~ 5)) & f(2 * (0,1))^m(0,1);
+ * char c[2][6] = { "hello", "" };
+ */
+#define L21 f(y+1) + f(f(z)) % t(t(g)(0) + t)(1);
+#define L22 g(x+(3,4)-w) | h 5) & m\
+(f)^m(m);
+L21
+L22
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/02.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/02.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/02.expect	(revision 331)
@@ -0,0 +1,5 @@
+f(2 * (y+1)) + f(2 * (f(2 * (z[0])))) % f(2 * (0)) + t(1);
+f(2 * (2 +(3,4)-0,1)) | f(2 * (~ 5)) & f(2 * (0,1))^m(0,1);
+char c[2][6] = { "hello", "" };
+f(2 * (y+1)) + f(2 * (f(2 * (z[0])))) % f(2 * (0)) + t(1);
+f(2 * (2 +(3,4)-0,1)) | f(2 * (~ 5)) & f(2 * (0,1))^m(0,1);
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/03.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/03.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/03.c	(revision 331)
@@ -0,0 +1,15 @@
+#define str(s) # s
+#define xstr(s) str(s)
+#define debug(s, t) printf("x" # s "= %d, x" # t "= %s", \
+	x ## s, x ## t)
+#define INCFILE(n) vers ## n
+#define glue(a, b) a ## b
+#define xglue(a, b) glue(a, b)
+#define HIGHLOW "hello"
+#define LOW LOW ", world"
+debug(1, 2);
+fputs(str(strncmp("abc\0d", "abc", '\4') // this goes away
+	== 0) str(: @\n), s);
+\#include xstr(INCFILE(2).h)
+glue(HIGH, LOW);
+xglue(HIGH, LOW)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/03.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/03.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/03.expect	(revision 331)
@@ -0,0 +1,5 @@
+printf("x" "1" "= %d, x" "2" "= %s", x1, x2);
+fputs("strncmp(\"abc\\0d\", \"abc\", '\\4') == 0" ": @\n", s);
+\#include "vers2.h"
+"hello";
+"hello" ", world"
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/04.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/04.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/04.c	(revision 331)
@@ -0,0 +1,4 @@
+#define foobar 1
+#define C(x,y) x##y
+#define D(x) (C(x,bar))
+D(foo)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/04.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/04.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/04.expect	(revision 331)
@@ -0,0 +1,1 @@
+(1)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/05.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/05.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/05.c	(revision 331)
@@ -0,0 +1,7 @@
+#define t(x,y,z) x ## y ## z
+#define xxx(s) int s[] = { t(1,2,3), t(,4,5), t(6,,7), t(8,9,), \
+        t(10,,), t(,11,), t(,,12), t(,,) };
+
+int j[] = { t(1,2,3), t(,4,5), t(6,,7), t(8,9,),
+	t(10,,), t(,11,), t(,,12), t(,,) };
+xxx(j)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/05.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/05.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/05.expect	(revision 331)
@@ -0,0 +1,3 @@
+int j[] = { 123, 45, 67, 89,
+ 10, 11, 12, };
+int j[] = { 123, 45, 67, 89, 10, 11, 12, };
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/06.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/06.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/06.c	(revision 331)
@@ -0,0 +1,5 @@
+#define X(a,b, \
+	c,d) \
+	foo
+
+X(1,2,3,4)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/06.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/06.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/06.expect	(revision 331)
@@ -0,0 +1,1 @@
+foo
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/07.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/07.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/07.c	(revision 331)
@@ -0,0 +1,4 @@
+#define a() YES
+#define b() a
+b()
+b()()
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/07.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/07.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/07.expect	(revision 331)
@@ -0,0 +1,2 @@
+a
+YES
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/08.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/08.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/08.c	(revision 331)
@@ -0,0 +1,4 @@
+// test macro expansion in arguments
+#define s_pos              s_s.s_pos
+#define foo(x) (x)
+foo(hej.s_pos)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/08.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/08.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/08.expect	(revision 331)
@@ -0,0 +1,1 @@
+(hej.s_s.s_pos)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/09.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/09.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/09.c	(revision 331)
@@ -0,0 +1,4 @@
+#define C(a,b,c) a##b##c
+#define N(x,y) C(x,_,y)
+#define A_O aaaaoooo
+N(A,O)
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/09.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/09.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/09.expect	(revision 331)
@@ -0,0 +1,1 @@
+aaaaoooo
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/10.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/10.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/10.c	(revision 331)
@@ -0,0 +1,10 @@
+#define f(x) x
+#define g(x) f(x) f(x
+#define i(x) g(x)) g(x
+#define h(x) i(x))) i(x
+#define k(x) i(x))) i(x))))
+f(x)
+g(x))
+i(x)))
+h(x))))
+k(x))))
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/10.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/10.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/10.expect	(revision 331)
@@ -0,0 +1,5 @@
+x
+x x
+x x x x
+x x x x x x x x
+x x x x x x x x))))
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/11.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/11.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/11.c	(revision 331)
@@ -0,0 +1,31 @@
+#define D1(s, ...) s
+#define D2(s, ...) s D1(__VA_ARGS__)
+#define D3(s, ...) s D2(__VA_ARGS__)
+#define D4(s, ...) s D3(__VA_ARGS__)
+
+D1(a)
+D2(a, b)
+D3(a, b, c)
+D4(a, b, c, d)
+
+x D4(a, b, c, d) y
+x D4(a, b, c) y
+x D4(a, b) y
+x D4(a) y
+x D4() y
+
+#define GNU_COMMA(X,Y...) X,## Y
+
+x GNU_COMMA(A,B,C) y
+x GNU_COMMA(A,B) y
+x GNU_COMMA(A) y
+x GNU_COMMA() y
+
+#define __sun_attr___noreturn__ __attribute__((__noreturn__))
+#define ___sun_attr_inner(__a) __sun_attr_##__a
+#define __sun_attr__(__a) ___sun_attr_inner __a
+#define __NORETURN __sun_attr__((__noreturn__))
+__NORETURN
+#define X(...)
+#define Y(...)  1 __VA_ARGS__ 2
+Y(X X() ())
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/11.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/11.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/11.expect	(revision 331)
@@ -0,0 +1,15 @@
+a
+a b
+a b c
+a b c d
+x a b c d y
+x a b c y
+x a b y
+x a y
+x y
+x A,B,C y
+x A,B y
+x A y
+x y
+__attribute__((__noreturn__))
+1 2
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/12.S
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/12.S	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/12.S	(revision 331)
@@ -0,0 +1,8 @@
+#define SRC(y...)                       \
+        9999: y;                        \
+        .section __ex_table, "a";       \
+        .long 9999b, 6001f      ;       \
+        // .previous
+
+    SRC(1: movw (%esi), %bx)
+6001:
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/12.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/12.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/12.expect	(revision 331)
@@ -0,0 +1,2 @@
+    9999: 1: movw (%esi), %bx; .section __ex_table, "a"; .long 9999b, 6001f ;
+6001:
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/13.S
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/13.S	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/13.S	(revision 331)
@@ -0,0 +1,6 @@
+# `modelist' label. Each video mode record looks like:
+#ifdef AAA
+# modelist' label. Each video mode record looks like:
+#endif
+.text
+endtext:
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/13.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/13.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/13.expect	(revision 331)
@@ -0,0 +1,2 @@
+.text
+endtext:
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/14.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/14.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/14.c	(revision 331)
@@ -0,0 +1,13 @@
+#define W Z
+#define Z(X) W(X,2)
+#define Y(X) Z(X)
+#define X Y
+return X(X(1));
+
+#define P Q
+#define Q(n) P(n,2)
+return P(1);
+
+#define A (B * B)
+#define B (A + A)
+return A + B;
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/14.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/14.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/14.expect	(revision 331)
@@ -0,0 +1,3 @@
+return Z(Z(1,2),2);
+return Q(1,2);
+return ((A + A) * (A + A)) + ((B * B) + (B * B));
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/15.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/15.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/15.c	(revision 331)
@@ -0,0 +1,18 @@
+// insert a space between two tokens if otherwise they
+// would form a single token when read back
+
+#define n(x) x
+
+return (n(long)n(double))d;
+return n(A)n(++)n(+)n(B);
+return n(A)n(+)n(++)n(B);
+return n(A)n(++)n(+)n(+)n(B);
+
+// not a hex float
+return n(0x1E)n(-1);
+
+// unlike gcc but correct
+// XXX: return n(x)+n(x)-n(1)+n(1)-2;
+
+// unlike gcc, but cannot appear in valid C
+// XXX: return n(x)n(x)n(1)n(2)n(x);
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/15.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/15.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/15.expect	(revision 331)
@@ -0,0 +1,5 @@
+return (long double)d;
+return A+++B;
+return A+ ++B;
+return A+++ +B;
+return 0x1E -1;
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/16.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/16.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/16.c	(revision 331)
@@ -0,0 +1,3 @@
+/* The following should warn */
+#define A ...
+#define A <<=
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/16.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/16.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/16.expect	(revision 331)
@@ -0,0 +1,2 @@
+
+16.c:3: warning: A redefined
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/17.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/17.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/17.c	(revision 331)
@@ -0,0 +1,14 @@
+#define STR1(u) # u
+#define pass(a) a
+#define __ASM_REG(reg)         STR1(one##reg)
+#define _ASM_DX         __ASM_REG(tok)
+X162 pass(__ASM_REG(tok))
+X161 pass(_ASM_DX)
+X163 pass(STR1(one##tok))
+
+X170 pass(x ## y)
+X171 pass(x pass(##) y)
+
+#define Y(x) Z(x)
+#define X Y
+X180 return X(X(1));
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/17.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/17.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/17.expect	(revision 331)
@@ -0,0 +1,6 @@
+X162 "onetok"
+X161 "onetok"
+X163 "one##tok"
+X170 x ## y
+X171 x ## y
+X180 return Z(Z(1));
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/18.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/18.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/18.c	(revision 331)
@@ -0,0 +1,15 @@
+#define M_RETI_ARG27(x,y,z,aa, ...)    aa
+#define M_RET_ARG27(...)        M_RETI_ARG27(__VA_ARGS__)
+#define M_COMMA_P(...)          M_RET_ARG27(__VA_ARGS__, 1, 1, 0, useless)
+#define M_EMPTYI_DETECT(...)    0, 1,
+#define M_EMPTYI_P_C1(...)      M_COMMA_P(M_EMPTYI_DETECT __VA_ARGS__ () )
+#define EX
+#define empty(x)
+#define fnlike(x) yeah x
+/* If the following macro is called with empty arg (X183), the use
+   of 'x' between fnlike and '(' doesn't hinder the recognition of this
+   being a further fnlike macro invocation.  */
+#define usefnlike(x) fnlike x (x)
+X181 M_EMPTYI_P_C1()
+X182 M_EMPTYI_P_C1(x)
+X183 usefnlike()
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/18.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/18.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/pp/18.expect	(revision 331)
@@ -0,0 +1,3 @@
+X181 1
+X182 0
+X183 yeah
